cascading.flow.local

## Class LocalFlow

- java.lang.Object
- - cascading.flow.BaseFlow<java.util.Properties>
  - - cascading.flow.local.LocalFlow

- All Implemented Interfaces:
    Flow<java.util.Properties>, UnitOfWork<FlowStats>, ProcessLogger

      public class LocalFlow
      extends BaseFlow<java.util.Properties>

  Class LocalFlow is the local mode specific implementation of a `Flow`.

  LocalFlow must be created through a `LocalFlowConnector` instance.

  If classpath paths are provided on the `FlowDef`, the context classloader used to internally urn the current Flow will be swapped out with an URLClassLoader pointing to each element.
  See Also:
    `LocalFlowConnector`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class cascading.flow.BaseFlow

      `BaseFlow.FlowHolder`

  - ### Field Summary

    - ### Fields inherited from class cascading.flow.BaseFlow

      `completed, flowCanonicalHash, flowDescriptor, flowElementGraph, flowStats, flowStepGraph, platformInfo, shutdownHook, sinks, sources, steps, stop, stopJobsOnExit, thread, throwable`

    - ### Fields inherited from interface cascading.flow.Flow

      `CASCADING_FLOW_ID`

    - ### Fields inherited from interface cascading.util.ProcessLogger

      `NULL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LocalFlow(PlatformInfo platformInfo, java.util.Map<java.lang.Object,java.lang.Object> properties, java.util.Properties config, FlowDef flowDef)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.Thread` | `createFlowThread(java.lang.String threadName)`
    `java.util.Properties` | `getConfig()` Method getConfig returns the internal configuration object.
    `java.util.Map<java.lang.Object,java.lang.Object>` | `getConfigAsProperties()` Method getConfigAsProperties converts the internal configuration object into a `Map` of key value pairs.
    `java.util.Properties` | `getConfigCopy()` Method getConfigCopy returns a copy of the internal configuration object.
    `FlowProcess<java.util.Properties>` | `getFlowProcess()`
    `protected int` | `getMaxNumParallelSteps()`
    `java.lang.String` | `getProperty(java.lang.String key)` Returns the String property associated with the given key from the current Configuration instance.
    `protected void` | `initConfig(java.util.Map<java.lang.Object,java.lang.Object> properties, java.util.Properties parentConfig)` This method creates a new internal Config with the parentConfig as defaults using the properties to override the defaults.
    `protected void` | `internalClean(boolean stop)`
    `protected void` | `internalShutdown()`
    `protected void` | `internalStart()`
    `protected java.util.Properties` | `newConfig(java.util.Properties defaultConfig)`
    `protected void` | `setConfigProperty(java.util.Properties properties, java.lang.Object key, java.lang.Object value)`
    `boolean` | `stepsAreLocal()` Method jobsAreLocal returns true if all jobs are executed in-process as a single map and reduce task.

    - ### Methods inherited from class cascading.flow.BaseFlow

      `addListener, addPlannerProperties, addSessionProperties, addStepListener, areSinksStale, areSourcesNewer, cleanup, complete, createConfig, createFlowCanonicalHash, createFlowStats, createPrepareFlowStats, deleteCheckpointsIfNotUpdate, deleteCheckpointsIfReplace, deleteSinks, deleteSinksIfNotUpdate, deleteSinksIfReplace, deleteTrapsIfNotUpdate, deleteTrapsIfReplace, fireOnCompleted, fireOnStarting, fireOnStopping, fireOnThrowable, fireOnThrowable, getCascadeID, getCascadingServices, getCheckpointNames, getCheckpoints, getCheckpointsCollection, getClassPath, getClientState, getEligibleJobsSize, getFieldsFor, getFlowCanonicalHash, getFlowDescriptor, getFlowElementGraph, getFlowSession, getFlowSkipStrategy, getFlowStats, getFlowStepGraph, getFlowSteps, getFlowStepStrategy, getHolder, getID, getJobMapCallables, getName, getPlannerInfo, getPlatformInfo, getRunID, getSink, getSink, getSinkModified, getSinkNames, getSinks, getSinksCollection, getSource, getSourceNames, getSources, getSourcesCollection, getSpawnStrategy, getStats, getSubmitPriority, getTags, getTotalSliceCPUMilliSeconds, getTrapNames, getTraps, getTrapsCollection, handleExecutorShutdown, hasListeners, hasStepListeners, initFromProperties, initialize, initializeChildStats, initializeNewJobsMap, initSteps, internalStopAllJobs, isDebugEnabled, isInfoEnabled, isJobsMapInitialized, isSkipFlow, isStopJobsOnExit, logDebug, logError, logError, logInfo, logWarn, logWarn, logWarn, openSink, openSink, openSource, openSource, openTapForRead, openTapForWrite, openTrap, openTrap, prepare, presentSinkFields, presentSourceFields, registerShutdownHook, removeListener, removeListeners, removeStepListener, resourceExists, retrieveSinkFields, retrieveSourceFields, setCascade, setCheckpoints, setFlowElementGraph, setFlowSkipStrategy, setFlowStepGraph, setFlowStepStrategy, setName, setPlannerInfo, setSinks, setSources, setSpawnStrategy, setSubmitPriority, setTraps, spawnSteps, start, stop, toString, updateJobsMap, updateSchemes, writeDOT, writeStepsDOT`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### LocalFlow

          public LocalFlow(PlatformInfo platformInfo,
                   java.util.Map<java.lang.Object,java.lang.Object> properties,
                   java.util.Properties config,
                   FlowDef flowDef)

  - ### Method Detail

    - #### initConfig

          protected void initConfig(java.util.Map<java.lang.Object,java.lang.Object> properties,
                        java.util.Properties parentConfig)

      Description copied from class: `BaseFlow`
      This method creates a new internal Config with the parentConfig as defaults using the properties to override the defaults.
      Specified by:
        `initConfig` in class `BaseFlow<java.util.Properties>`
      Parameters:
        `properties` - of type Map
        `parentConfig` - of type Config

    - #### setConfigProperty

          protected void setConfigProperty(java.util.Properties properties,
                               java.lang.Object key,
                               java.lang.Object value)

      Specified by:
        `setConfigProperty` in class `BaseFlow<java.util.Properties>`

    - #### newConfig

          protected java.util.Properties newConfig(java.util.Properties defaultConfig)

      Specified by:
        `newConfig` in class `BaseFlow<java.util.Properties>`

    - #### getConfig

          @ProcessConfiguration
          public java.util.Properties getConfig()

      Description copied from interface: `Flow`
      Method getConfig returns the internal configuration object.

      Any changes to this object will not be reflected in child steps. See `FlowConnector` for setting default properties visible to children. Or see `FlowStepStrategy` for setting properties on individual steps before they are executed.
      Returns:
        the default configuration of this Flow

    - #### getConfigCopy

          public java.util.Properties getConfigCopy()

      Description copied from interface: `Flow`
      Method getConfigCopy returns a copy of the internal configuration object. This object can be safely modified.
      Returns:
        a copy of the default configuration of this Flow

    - #### getConfigAsProperties

          public java.util.Map<java.lang.Object,java.lang.Object> getConfigAsProperties()

      Description copied from interface: `Flow`
      Method getConfigAsProperties converts the internal configuration object into a `Map` of key value pairs.
      Returns:
        a Map of key/value pairs

    - #### getProperty

          public java.lang.String getProperty(java.lang.String key)

      Description copied from interface: `Flow`
      Returns the String property associated with the given key from the current Configuration instance.
      Parameters:
        `key` - of type String
      Returns:
        the String value

    - #### getFlowProcess

          public FlowProcess<java.util.Properties> getFlowProcess()

    - #### internalStart

          protected void internalStart()

      Specified by:
        `internalStart` in class `BaseFlow<java.util.Properties>`

    - #### createFlowThread

          protected java.lang.Thread createFlowThread(java.lang.String threadName)

      Overrides:
        `createFlowThread` in class `BaseFlow<java.util.Properties>`

    - #### internalClean

          protected void internalClean(boolean stop)

      Specified by:
        `internalClean` in class `BaseFlow<java.util.Properties>`

    - #### stepsAreLocal

          public boolean stepsAreLocal()

      Description copied from interface: `Flow`
      Method jobsAreLocal returns true if all jobs are executed in-process as a single map and reduce task.
      Returns:
        boolean

    - #### getMaxNumParallelSteps

          protected int getMaxNumParallelSteps()

      Specified by:
        `getMaxNumParallelSteps` in class `BaseFlow<java.util.Properties>`

    - #### internalShutdown

          protected void internalShutdown()

      Specified by:
        `internalShutdown` in class `BaseFlow<java.util.Properties>`

Copyright © 2007-2015 Xplenty, Inc. All Rights Reserved.